
import { FormBuilder, Validators } from '@angular/forms';
import { CustomValidators } from 'ng2-validation';
import { BsModalService } from "ngx-bootstrap/modal";

import * as _ from 'lodash';
import { FlexTableComponent } from '../../../../shared/common/FlexTable.component';
import { OnInit, Component } from '@angular/core';

import { FrameRequest } from '../../../../shared/frame/frame-request';
import { AppComponent } from '../../../..';

//审批状态
const APPLY_STATUS = {
    NEW: 0,//草稿
    LOCAL_VERIFY: 1,//待现场验证
    PROV_VERIFY:2,//待省级验证
    ARCHIVE:3//归档
};

@Component({
    selector: 'cert_nedu_apply_local',
    templateUrl: './cert_nedu_apply.component.local.html',
    styleUrls: ['./cert_nedu_apply.component.local.scss']
})
export class CertNeduApplyComponentLocal extends FlexTableComponent implements OnInit {
    
    ngOnInit() {
        FrameRequest.requestArray('cf/cfOrganization/list.htm', {org_type: [1,4], status: 1}, (array) => {
            this.orgList = array;
          }); 
       
      }

    public query = {
        "std_name": "",
        "std_cert_no": "",
        "cert_type_id": "",
        "time_config_id": "",
        "isdo":"",
        "is_atg":"",
        "status":"",
        "org_id":""
    };

    QUERY_URL = "mk/mkCertNeduApply/page.htm";
    DELETE_URL = "mk/mkCertNeduApply/delete.htm";
    GET_URL = "mk/mkCertNeduApply/get.htm";
    ADD_URL = "mk/mkCertNeduApply/add.htm";
    EDIT_URL = "mk/mkCertNeduApply/edit.htm";
    GO_VERIFT_URL = "mk/mkCertNeduApply/goVerify.htm";

    CERT_TYPE_List_URL= "mk/mkCertType/listAll.htm";
    CERT_TYPE_COURSE_URL= "mk/mkCertNeduApply/getCourse.htm"
    APPLY_VERIFY_URL = "mk/mkCertNeduApply/verify.htm";

    certTypeList = null;
    courseList = null;

    bsModalWin_verify : any;
    orgList:any;

    bsModalWin2 = null;
    file_path = null;
    curr_id = null;
    current = 0;

    constructor(
        public bsModalService: BsModalService,
        fb: FormBuilder
    ) {
        super();
        // CustomValidators.rangeLength([1, 6])
        this.formModel = fb.group({
            id: [null],
            'std_name': [null],
            'std_cert_no': [null],
            'cert_no': [null],
            'cert_type_id': [null],
            'status': [null],
            'exam_date': [null],
            'file_path': [null],
            'verify_remark2': [null],
            'verify_remark3': [null],
            'verify_remark1': [null],
        });

        FrameRequest.requestArray(this.CERT_TYPE_List_URL, {}, (array) => {
            this.certTypeList = array;
          });

    }

    search(param) {
        if(!this.query.time_config_id){
            this.query.time_config_id = "";
        }
        if(!this.query.org_id){
            this.query.org_id = "";
        }

        let searchCondition = this.query;
        //参数合并
        _.assignIn(param, searchCondition);
    }

    //导出
  export() {
    AppComponent.GobalComponent.setLoading(true);
    FrameRequest.download("mk/mkCertNeduApply/export.htm", {
        std_name : this.query.std_name,
        std_cert_no : this.query.std_cert_no,
        cert_type_id : this.query.cert_type_id,
        time_config_id: this.query.time_config_id,
        isdo: this.query.isdo,
        is_atg:this.query.is_atg,
        status: this.query.status,
        org_id: this.query.org_id
    }, () => {
      AppComponent.GobalComponent.setLoading(false);
      AppComponent.GobalComponent.successMsg("导出成功");
    });
  }

  callBack(){
    let checkedArray =  this.framePager.getCheckedArray();
    if(checkedArray.length == 0 ||checkedArray.length>1){
        AppComponent.alert({title:"信息提示",text:"请选择一条数据!"});
        return;
    }

    AppComponent.confirm("确定撤回吗?",()=>{
        FrameRequest.request("mk/mkCertNeduApply/callBack.htm", {apply_id:checkedArray[0].id}, async ()=>{
            //刷新
           this.framePager.reload();
            AppComponent.GobalComponent.successMsg("撤回成功!");
        
        });
    });

  }
    goVerify(tpl,item){
       

        FrameRequest.requestMap(this.CERT_TYPE_COURSE_URL, {cert_type_id: item.id}, (map) => {
            this.item = map['apply'];
            this.courseList = map['courseList'];

            this.shouModalWin_verify(tpl);

            this.item.status = "1";
            this.item.verify_remark1 = '同意上报';
            
         });
    }

    async shouModalWin_verify(editFormTemplateModal, modalcss?) {
        if(!this.item) this.item = {};
        let css = modalcss ? modalcss : "modal-lg";
        this.bsModalWin= this.bsModalService.show(editFormTemplateModal, { class: css });
    }

    //现场审批
    saveVerify(){
        
        if(this.item.status_text != "待现场验证"){
            AppComponent.alert({title:"信息提示",text:"申请单状态不是待现场验证，不允许审批!"});
            return
        }
        
        if(!(this.item.status+"")){
            AppComponent.alert({title:"信息提示",text:"请填写审批状态!"});
            return
        }
        if(!this.item.verify_remark1 || this.item.verify_remark1.lengh == 0){
            AppComponent.alert({title:"信息提示",text:"请填写审批意见!"});
            return
        }
        let verfiyStatus;
        switch (this.item.status) {
            case "0":
                verfiyStatus = APPLY_STATUS.NEW
                break;
            case "1":
                verfiyStatus = APPLY_STATUS.PROV_VERIFY
                break;
            default:
                break;
        }

        AppComponent.confirm("确定提交吗?",()=>{
            FrameRequest.requestMap(this.APPLY_VERIFY_URL, 
                { apply_id: this.item.id, status: verfiyStatus,verify_remark1:this.item.verify_remark1}, (map) => {
                    AppComponent.alert({title:"信息提示",text:"审批提交成功!"});
                    this.hideModal();
                   this.framePager.reload();
             });
        });

        
    }

    downloadTemplate() {
        FrameRequest.download('/std/stdRegInfo/downloadTpl.htm', {fileName: 'mk_apply.doc'});
    }

    downApplyPDF(){
        let checkArray = this.framePager.getCheckedArray();
  
        if(checkArray.length != 1){
          AppComponent.alert({title:"信息提示",text:"请单选一条申请数据!"});
          return
        }

        FrameRequest.requestEntity("mk/mkCertEduApply/checkDownApplyPDF.htm", {std_id:checkArray[0].std_reg_id,time_config_id:checkArray[0].time_config_id}, (entity) => {
            this.item = entity;
            if(entity){
                AppComponent.confirm(entity,()=>{
                    FrameRequest.download('mk/mkCertEduApply/downApplyPDF.htm', {std_id:checkArray[0].std_reg_id,time_config_id:checkArray[0].time_config_id});
                });     
            }else{
                FrameRequest.download('mk/mkCertEduApply/downApplyPDF.htm', {std_id:checkArray[0].std_reg_id,time_config_id:checkArray[0].time_config_id});
            }
           
         });

      }

      changeRemark(remark){
        this.item.verify_remark1=remark;
    }

    isPakage(path){
        if(path.indexOf('zip') != -1 || path.indexOf('rar') != -1){
            return true;
        }
        return false;
    }
    
showImg(editFormTemplateModal,path) {
    this.file_path = path;
    this.curr_id = path;
    this.current =0;
   
    let css = "modal-bg";
    this.bsModalWin2 = this.bsModalService.show(editFormTemplateModal, { class: css });
  
  }
  
  rotate(i){
  
    var imge = document.getElementById(this.curr_id);
    if(i ==0){
      this.current = (this.current-90)%360
    }else if(i ==1){
      this.current = (this.current+90)%360
    }
  
    
  
  imge.style.transform='rotate('+this.current+'deg)';
  
  if(imge.offsetWidth>imge.offsetHeight){
    imge.style.marginTop = (imge.offsetWidth-imge.offsetHeight)/2+"px";
  
  }
    
  }
}


